/*========================================
 * format d'objet pour mode 3d
 * Erreurs n 5x
 *----------------------------------------
 * (c) Disk91 / TeKnO-BeDoUiNs
 *========================================
 */

 #ifndef _LWO_H_
 #define _LWO_H_
 #include "3d.h"

 #define LWOERROR(x,y) { allegro_exit();                         \
                         printf(" Erreur LWO n %d\n  ",y);     \
                         puts(x) ; exit(y);                      \
                       }

 typedef struct lwo_srf
 {
    char     name[256];             // nom de la surface
    int      cr,cg,cb;              // couleur
    int      type;                  // type de rendue
    BITMAP * map;                   // mapping
 } LWO_SRF;

 typedef struct lwo_srf_info
 {

    int        nbsurf;
    LWO_SRF  * surf;

 } LWO_SRF_INFO;


 /*------------------------------------
  * Prototypes
  *------------------------------------
  */

  // primitives d'acces au fichier
  int                  lwo_get_int( PACKFILE * f );
  unsigned short int   lwo_get_sint( PACKFILE * f );
  float                lwo_get_float( PACKFILE * f );
  char               * lwo_get_id4( PACKFILE * f );
  int                  lwo_get_string( PACKFILE * f, char * str );
  int                  lwo_find_chunck( PACKFILE * f, char * chunck );

  // primitive de creation/destruction de structures
  LWO_SRF_INFO       * lwo_create_srf( int nbsurf );
  void                 lwo_destroy_srf( LWO_SRF_INFO * srf);

  // fonctions principales
  OBJECT_f           * load_lwo_f( char * filename );
  LWO_SRF_INFO       * load_lwo_srf( char * filename );

/*-------------------------------------
 * Variables externes
 *-------------------------------------
 */
 extern int lwo_vtx_by_poly;

 #endif

