/*===================================================================
 * Primitive pour la lecture de fichier lwo
 *-------------------------------------------------------------------
 * (c) Disk91 / TeKnO-BeDoUiNs / 12-1998
 *===================================================================
 */

 #include <allegro.h>
 #include "lwo.h"

  /*--- globals ---*/
  static char  disk_temp[5]={ ' ', ' ', ' ', ' ', '\0' };

 /*----------------------------------
  * Helpers for getting data
  *----------------------------------
  */
  int lwo_get_int( PACKFILE * f )
  {
     int    temp;
     char * ofs = (char * ) &temp;

     pack_fread( &ofs[3], 1, f );
     pack_fread( &ofs[2], 1, f );
     pack_fread( &ofs[1], 1, f );
     pack_fread( &ofs[0], 1, f );

     return ( temp );
  }

  unsigned short int lwo_get_sint( PACKFILE * f )
  {
     unsigned short int    temp;
     unsigned       char * ofs = (unsigned char *) &temp;

     pack_fread( &ofs[1], 1, f );
     pack_fread( &ofs[0], 1, f );

     return ( temp );
  }

  float lwo_get_float( PACKFILE * f )
  {
     float  temp;
     char * ofs = (char *) &temp;

     pack_fread( &ofs[3], 1, f );
     pack_fread( &ofs[2], 1, f );
     pack_fread( &ofs[1], 1, f );
     pack_fread( &ofs[0], 1, f );

     return ( temp );
  }

  char * lwo_get_id4( PACKFILE * f )
  {
     pack_fread( &disk_temp[0], 1, f );
     pack_fread( &disk_temp[1], 1, f );
     pack_fread( &disk_temp[2], 1, f );
     pack_fread( &disk_temp[3], 1, f );

     return ( disk_temp );
  }


  int lwo_get_string( PACKFILE * f, char * str )
  {
    // lecture d'une chaine de caractere finissant par 2 zeros
    // revoie le nb de caract lus
    int nb = 0;

    do
    {
       pack_fread( &str[nb], 1, f );
       nb++;
    }  while ( nb < 2 ||  str[nb-1] != 0 || str[nb-2] != 0  );
    str[nb-2] = '\0';

    return nb;
  }

 /*----------------------------------
  * Helpers for finding chunks
  *----------------------------------
  */
  int lwo_find_chunck( PACKFILE * f, char * chunck )
  {
     do
     {
        do
        {
           pack_fread( &disk_temp[0],1, f );
        }
        while ( disk_temp[0] != chunck[0] && !pack_feof(f) );

        while ( disk_temp[0] == chunck[0] )
        {
           pack_fread( &disk_temp[0],1, f );
           if ( disk_temp[0] == chunck[1] && !pack_feof(f) )
           {
              pack_fread( &disk_temp[0],1, f );
              if ( disk_temp[0] == chunck[2] && !pack_feof(f) )
              {
                 pack_fread( &disk_temp[0],1, f );
                 if ( disk_temp[0] == chunck[3] && !pack_feof(f) )
                    return 1;
              }
           }
        }
    } while ( !pack_feof(f) );
    return (0);
 }

/*============================================================
 * Helper for creating and destroying SRF struct
 *============================================================
 */

 LWO_SRF_INFO * lwo_create_srf( int nbsurf )
 {
    LWO_SRF_INFO * out;

    out = (  LWO_SRF_INFO * ) malloc ( sizeof ( LWO_SRF_INFO ) );

    out->nbsurf = nbsurf;
    out->surf   = ( LWO_SRF * ) malloc ( nbsurf * sizeof ( LWO_SRF ) );

    return ( out );
 }

 void lwo_destroy_srf( LWO_SRF_INFO * srf)
 {
    free( srf->surf );
    free( srf );
 }
