/*==================================================================
 * recuperation des informations de surface
 *------------------------------------------------------------------
 * (c) Disk91 / TeKno-BeDoUiNs / 12-1998
 *==================================================================
 */

 #include <stdio.h>
 #include <allegro.h>
 #include "3d.h"
 #include "lwo.h"

 /*---------------------------------------------------------------------------
  * primitives
  *---------------------------------------------------------------------------
  */


 /*---------------------------------------------
  * get_srfinfos : renvoie le nombre de surfaces
  *     differentes dans un objet
  *---------------------------------------------
  */
  static int get_srfinfos( int * nbsrf, char * filename )
  {
     PACKFILE * file;

     char     * token;
     int              srfl;             // taille des donnees de nom de surface
     int              csrfl;            // taille des donnees lues
     char             tstr[200];        // buffer temporaire pour lecture des noms

     file = pack_fopen( filename, "rb" );
     if ( file )
     {
        token  = lwo_get_id4( file );
        if ( strcmp( token, "FORM" ) )   /*--- test for LW file ---*/
           LWOERROR("Fichier non standard LWO",52)
        lwo_get_int( file );                 /*--- jump for data size ---*/

        token  = lwo_get_id4( file );
        if ( strcmp( token, "LWOB" ) )   /*--- test for LWO file ---*/
           LWOERROR("Fichier non standard LWO",52)

        /*--- get the number of surf information name ---*/
        if ( !lwo_find_chunck( file,"SRFS" ) )    /*--- find surface name chunck ---*/
          *nbsrf = 0;
        else
        {
          *nbsrf = 0;
          // recupere la taille complette des infos de nom de surface
          srfl   = lwo_get_int( file );
          csrfl  = 0;
          // lecture un a un des noms de surface
          while ( csrfl < srfl )
          {
             csrfl += lwo_get_string( file, tstr );
             (*nbsrf)++;
          }
          // verifie par securite que l'on tombe juste
          if ( csrfl != srfl )
            LWOERROR("fichier LWO corrompu",54)
        }
       pack_fclose(file);
       return ( 0 );
    }
    return ( -1 );
 }





/*============================================================================
 * Fonction principale de recuperation d'info de face
 *  Lecture d'un fichier lwo, remplie une structure avec les infos
 *  de surface
 *============================================================================
 */
  LWO_SRF_INFO * load_lwo_srf( char * filename )
  {
    PACKFILE     * file;
    LWO_SRF_INFO * srf;
    int        nbsrf;                   // nombre de surfaces differentes

    int        i;

    if ( get_srfinfos( &nbsrf, filename ) != -1 )
    {
       // pas d'infos de surface ?
       if ( nbsrf == 0 )
          return (NULL);

       file = pack_fopen( filename, "rb" );

       // creation des surfaces avec les infos de get_srfinfos
       srf    = lwo_create_srf( nbsrf );

       lwo_get_id4( file );                         // jump FROM chunck
       lwo_get_int( file );                         // jump data size
       lwo_get_id4( file );                         // jump LWO chunck

       // lecture des noms des surfaces, classement par indice
       lwo_find_chunck( file,"SRFS" );              // find SRFS chunck
       lwo_get_int( file );                         // jump srfs size
       for ( i = 0 ; i < srf->nbsurf ; i++ )
          lwo_get_string( file, srf->surf[i].name );




       pack_fclose(file);
       return ( srf );
    }
    else
       LWOERROR("Impossible de lire le fichier .lwo",53)
 }







