#include <stdio.h>
#include <allegro.h>
#include "lwo.h"
#include "3d.h"
#include "bsp.h"

#define USEBSP  1               /*--- on utilise un arbre BSP pour le trie ---*/
#define FICHIER "alakon.lwo"


OBJECT_f     * objet  = NULL;
OBJECT_f     * objet1 = NULL;
BITMAP       * dblbuff;
LWO_SRF_INFO * surfaces;


volatile int frame_count = 0;
volatile int fps = 0;

void fps_proc()
{
   fps = frame_count;
   frame_count = 0;
}
END_OF_FUNCTION(fps_proc);



int main(int argv, char ** argc)
{

   RGB      coul = { 63,45,18,0 };
   RGB      coul1 = { 63,0,0,0 };
   RGB      blk  = { 0,0,0,0 };
   PALETTE  pal;
   BITMAP * bmp[2];
   BSP    * tree;

   V3D_f    observ;

   int  i,j;
   float    xrot,yrot,zrot,tz,scale,ty,tx;
   int      fin = 0;
   int      key;
   int      page;
   int      card,TX,TY;

   allegro_init();
   install_keyboard();
   install_timer();
   install_mouse();
   check_cpu();

   /*--- creation palette ---*/
   pal[0].r = 0;
   pal[0].g = 0;
   pal[0].b = 0;
   for ( i = 1 ; i < 256 ; i++ )
   {
      pal[i].r = 32+(rand() >> 26);
      pal[i].g = 32+(rand() >> 26);
      pal[i].b = 32+(rand() >> 26);
   }

   objet1   = load_lwo_f( FICHIER );
   if ( !objet1 )
   {
      allegro_exit();
      printf(" Error while loading scene \n");
      exit(2);
   }
   normalize_object_f( objet1 );
   printf(" Memoire desiree : %d\n", memory_object_f);
   printf("Poly : %d\nVtx : %d\n",objet1->nb_vtx, objet1->nb_poly_begin);
//   tree = Build_Bsp3d( objet1, &objet, 20000, 20000, lwo_vtx_by_poly, "alakon.rot" );
   tree = Build_Bsp3d_optim( objet1, &objet, "alakon.rot" );

   printf(" Memoire desiree : %d\n", memory_object_f);
   printf("Poly : %d\nVtx : %d\n",objet->nb_vtx, objet->nb_poly_begin);
//   destroy_object_f(objet);
   while(!keypressed());readkey();
//   exit(0);


//   surfaces = load_lwo_srf( FICHIER );

   LOCK_VARIABLE(frame_count);
   LOCK_VARIABLE(fps);
   LOCK_FUNCTION(fps_proc);
   install_int_ex(fps_proc, BPS_TO_TIMER(1));


   card = GFX_VESA2L;
   TX   = 320;
   TY   = 200;
   set_gfx_mode(GFX_VGA, 320, 200, 0, 0);
   set_palette(desktop_palette);
   if (!gfx_mode_select(&card, &TX, &TY ) )
      return 0;

   set_color_depth(8);
   if (set_gfx_mode(card, TX, TY, TX, TY ) != 0)
   {
      allegro_exit();
      puts(" Erreur : mode non supporte");
      return 1;
   }


   bmp[0] = create_bitmap(TX, TY);
   if ( !bmp[0] )
   {
      puts(" Impossible d'allouer le buffer video");
      allegro_exit();
      exit(3);
   }

   set_projection_viewport(0,0,TX,TY);
   set_clip(bmp[0],0,0,TX,TY);
   set_palette(pal);


   xrot = 120.0;
   yrot = 56.0;
   zrot = 2.0;
   tz   = 85.0;
   ty   = 0;
   tx   = 0;
   scale = 1.0;
   page = 1;
   while( !fin )
   {
      dblbuff = bmp[0];
      clear(bmp[0]);

      if ( keypressed() )
      {
        key = ( readkey() & 0xff );
        if ( key == '2' ) xrot += 3;
        if ( key == '8' ) xrot -= 3;
        if ( key == '4' ) yrot += 3;
        if ( key == '6' ) yrot -= 3;
        if ( key == '5' ) fin   = 1;
        if ( key == '1' ) tz   += 1;
        if ( key == '7' ) tz   -= 1;
        if ( key == '+' ) scale ++;
        if ( key == '-' ) ( scale == 1 ) ? scale = 1 : scale--;
        if ( key == '9' ) ty   += 1;
        if ( key == '3' ) ty   -= 1;
        if ( key == '0' ) tx   -= 1;
        if ( key == '.' ) tx   += 1;
        if ( xrot > 255 ) xrot = 0;
        if ( xrot <   0 ) xrot = 255;
        if ( yrot > 255 ) yrot = 0;
        if ( yrot <   0 ) yrot = 255;
        if ( zrot > 255 ) zrot = 0;
        if ( zrot <   0 ) zrot = 255;
        while ( keypressed() ) readkey();
      }

//set_color(0,&coul1);
      Update_Plan( 130.0,tx, ty, tz, xrot, yrot, zrot, scale );
      Draw_Bsp3d( tree, objet, lwo_vtx_by_poly );

textprintf(dblbuff,font,0,40,58,"poly : %d",objet->nb_poly_end);

      transform4bsp_object_f( objet, scale,   xrot, yrot, zrot,   tx, ty, tz );
      clip3d4bsp_object_f( objet, POLYTYPE_FLAT, 0.4 , 130.0 );
//set_color(0,&blk);

textprintf(dblbuff,font,0,15,10,"nb poly = %d",objet->nb_poly_end);
textprintf(dblbuff,font,0,25,10,"fps = %d",fps);
//textprintf(dblbuff,font,0,35,10,"memoire allouee = %f",memory_object_f/(1024.0*1024.0));
//set_color(0,&coul);

      for ( i = 0 ; i < objet->nb_poly_end ; i++ )
      {
         objet->ptpoly[i]->ptvtx2d[0]->c = objet->ptpoly[i]->coul;
         polygon3d_f(dblbuff, POLYTYPE_FLAT, NULL, objet->ptpoly[i]->nb_vtx,
                     objet->ptpoly[i]->ptvtx2d );
//if ( i > 1730 )
//{
//      blit( dblbuff, screen, 0,0,0,0,TX,TY );
//      while( !keypressed() ); readkey();
//}



      }

//set_color(0,&blk);
//      vsync();
      blit( dblbuff, screen, 0,0,0,0,TX,TY );
      frame_count++;

//set_color(0,&coul);
//set_color(0,&blk);

   }

   destroy_object_f(objet);
   destroy_bitmap(bmp[0]);
   allegro_exit();
   exit(0);
}
